//How to make selection vary spatially between subpopulations (could be used to test geographic mosaic of selection)

// specifically
//1. Mutations have beneficial effects in one subpopulation and deleterious effect in another subpopulation.
//2. Whether such mutations fix or not depends on 
// 	a. the strength of the fitness effects, 
// 	b. the migration rates between the subpopulations 
// 	c. and various other factors.

//___________________________________________________________________

 initialize() {
	initializeMutationRate(1e-7);
	initializeMutationType("m1",0.5,"f", 0.0); //neutral
	initializeMutationType("m2",0.5,"e", 0.1); //deleterious in p2
	//occasionally beneficial mutations are drawn from an exponential distribution with mean 0.1
	initializeGenomicElementType("g1", c(m1,m2), c(0.99,0.01));
	initializeGenomicElement(g1, 0, 99999);
	initializeRecombinationRate(1e-8);
}
1 {
	sim.addSubpop("p1",500);
	sim.addSubpop("p2",500);
	p1.setMigrationRates(p2, 0.1); //weak migration p2 > p1
	p2.setMigrationRates(p1, 0.5); //strong migration p1 > p2
}

fitness(m2, p2) {return 1/relFitness;} 
//no generation range is specified, therefore this fitness() callback is therefore active in every generation
//this callback is only used in population p2, this restricts the operation of the callback to only the specificed population (p2), this produces spatial variation in selection.
//
//relFitness says that fitness value that Slim would normally use for the mutation. By returning 1/relFitness two things happen
//	1. if all m2 mutations in p1 are of high fitness (2.0) then they become low fitness in p2 (1/2.0 == 0.5) and vice versa

//most importantly m2 draws from selection coefficients from an exponential DFE and thus it has a different selection coefficient.
//not called just once per generation
//IT IS CALLED ONCE PER INDIVIDUAL PER m2 MUTATION
//therefore it calculates a modified fitness effect for that mutation in that individual

// mutations will spread that are beneficial in p1, turning that subpopulation’s individuals green, but deleterious in p2, turning that subpopulation’s individuals red. With the recipe as written, these mutations will often fix; the strong migration from p1 versus the weak migration from p2 gives p1 an advantage, allowing it to force p2 to fix mutations that are deleterious in that context. If you reverse the migration bias, that will no longer happen; instead p2 will be able to force p1 to lose mutations that are beneficial in that context. One could easily use this model to explore this scenario in detail, with questions such as the effect of subpopulation size, migration rate, selection strength, and so forth. Since neutral mutations are also in the model, one could also ask questions about how these sorts of dynamics affect neutral diversity and divergence. Not bad for sixteen lines of code! 



10000 {sim.simulationFinished();}